---
variables:
  HELM_PROJECT: helm-charts
  KUBERNETES_NAMESPACE: my-app-ns

stages:
  - generate
  - deploy
 
chart-generator:
  stage: generate
  image: alpine:3.15
  script:
   - ./scripts/generate-pipeline.sh > generated-pipeline.yml
  artifacts:
    expire_in: 1 hour
    paths:
      - generated-pipeline.yml
  rules:
    - if: '$CI_COMMIT_TAG =~ "/^$/"'
      changes:
      - charts/**/*

chart-jobs:
  stage: generate
  needs:
    - chart-generator
  trigger:
    include:
      - artifact: generated-pipeline.yml
        job: chart-generator
    strategy: depend
  rules:
    - if: '$CI_COMMIT_TAG =~ "/^$/"'
      changes:
      - charts/**/*

deploy:
  stage: deploy
  image: curlimages/curl
  dependencies:
    - chart-generator
  script:
    - 'curl --fail --request POST --form token=$HELM_TRIGGER_STAGING_TOKEN --form ref=main "https://{{GITLAB_URL}}/api/v4/projects/{{PROJECT_NUM}}/trigger/pipeline"'
  rules:
    - if: '$CI_COMMIT_TAG =~ "/^$/"'
      changes:
      - charts/**/*
      when: manual
